// main program!

use core::fmt::Write;

use vanadium::*;

const _ERASE_ALL_DISPLAY: &str = "\x1B[2J";
const _MV_1_1: &str = "\x1B[H";

fn main() {
  let mut term = Terminal::new();
  //write!(term, "{}{}", ERASE_ALL_DISPLAY, MV_1_1).unwrap();
  write!(term, "\r\n").unwrap();
  /*
  for (key, value) in std::env::vars_os() {
    write!(term, "{:?}: {:?}\r\n", key, value).unwrap();
  }
  */
  term.flush().unwrap();

  loop {
    match term.poll_events().unwrap() {
      None => (),
      Some(TermEvent::Key { val: Key::Lit(CTRL_Q), .. }) => break,
      Some(TermEvent::Key { val: Key::Lit(CTRL_C), .. }) => break,
      Some(TermEvent::Key { val: Key::Lit(b'C'), mods: Mods::Ctrl }) => break,
      Some(TermEvent::Key { val: Key::Lit(byte), mods }) => {
        let c = byte as char;
        if c.is_ascii_control() {
          write!(
            term,
            "{mods:?} + 0x{b:02X} (decimal {b})\r\n",
            mods = mods,
            b = byte
          )
          .unwrap();
        } else {
          write!(term, "[{mods:?} + {ch:}]\r\n", mods = mods, ch = c).unwrap();
        }
      }
      Some(other) => {
        write!(term, "other event: {:?}\r\n", other).unwrap();
      }
    }
    term.flush().unwrap();
  }
}
